import { levelsTraversal } from './traversal';
import { setupPointer } from './treeLevelsPointer';
export var complexTraversal = function complexTraversal(tree, root, onStepIn, onNode, onStepOut, options) {
  var levelsPointer = setupPointer();
  var latestShape = root;
  levelsTraversal(tree, function (parentNode) {
    levelsPointer.stepIn(latestShape);
    onStepIn(parentNode, levelsPointer.getCurrent());
  }, function (node) {
    latestShape = onNode(node, levelsPointer.getCurrent());
  }, function (parentNode) {
    levelsPointer.getCurrent() && onStepOut(parentNode, levelsPointer.getCurrent());
    levelsPointer.stepOut();
  }, options);
};